//Start creating prefs.
//Set preferences
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs")){
	//Make a preferences for the variables.
	RTB_registerPref("Max Nitro (%)", "VehicleNitro", "$Pref::VehicleNitro::MaxNitro", "int 0 250", "Script_VehicleNitro", 100, 0, 0);
	RTB_registerPref("Max speed boost (%)", "VehicleNitro", "$Pref::VehicleNitro::MaxSpeedBoost", "int 0 100", "Script_VehicleNitro", 25, 0, 0);
	RTB_registerPref("Consume Rate (%)", "VehicleNitro", "$Pref::VehicleNitro::ConsumeRate", "int 0 10", "Script_VehicleNitro", 2, 0, 0);
	RTB_registerPref("Refill Rate (%)", "VehicleNitro", "$Pref::VehicleNitro::RefillRate", "int 0 10", "Script_VehicleNitro", 1, 0, 0);
}else{
	$Pref::VehicleNitro::MaxSpeedBoost=25; //Default CostPerStud
	$Pref::VehicleNitro::ConsumeRate=2;
	$Pref::VehicleNitro::RefillRate=1;
	$Pref::VehicleNitro::MaxNitro=100;
}

package VehicleNitroPackage
{
  function Armor::onMount(%this, %obj, %mount, %slot)
  {
    Parent::onMount(%this, %obj, %mount, %slot);

    if (!isFunction(%mount.getClassName(), "updateStatus"))
      return;

    if (!isEventPending(%mount.updateStatus) && isObject(%obj.client))
	  %obj.client.nitro = $Pref::VehicleNitro::MaxNitro;
      %mount.updateStatus();
  }

  function Armor::onUnMount(%this, %obj, %mount, %slot)
  {
    Parent::onUnMount(%this, %obj, %mount, %slot);

    if (isEventPending(%mount.updateStatus) && isObject(%obj.client))
      commandToClient(%obj.client, 'ClearBottomPrint');
  }
  
    function Armor::onTrigger(%this,%obj,%slot,%val){
		Parent::onTrigger(%this,%obj,%slot,%val);
		if(%slot == 0){ //Check if the value trigger is 2 (Jump)
		    if(%val == 1){ //If the trigger value is 1 (Clicked)
			    %obj.boosttrigger=1;
			}else{
				%obj.boosttrigger=0;
			}
		}
	}
};

activatePackage("VehicleNitroPackage");

function WheeledVehicle::updateStatus(%this,%client){
	cancel(%this.updateStatus);
	
	%maxnitro = $Pref::VehicleNitro::MaxNitro; //Set the maxnitro to the server pref.
	
	%obj = %this.getMountedObject(0); //Get the vehicle's first seated object.
	
	//Calculate the boosted velocity.
	%z = 0; //Boost velocity is adding 2 to the z coordinate.
	%forwardVector=%this.getForwardVector(); //Get the vehicle forward vector.
	%forwardX=getWord(%forwardVector,0);
	%forwardY=getWord(%forwardVector,1);
	%x=0; //These two variables are just being used to bypass an error...
	%y=2;
	//Finish calculating the variables needed in order to boost velocity.
	
	//Calculate speed.
	%speed = vectorLen(%this.getVelocity()) * 2;
	%speed = mFloatLength(%speed, 0);
	//Start creating offset.
	
	if(isObject(%obj.client)){ //If the object is a client do the code.
		if(%obj.boosttrigger){ //If the driver object is triggering his/her fire mouse.
		    if(%obj.client.nitro > 0){ //Check the client's current nitro.
				%obj.client.nitro -= $Pref::VehicleNitro::ConsumeRate; //Start using up nitro and add velocity to the code below.
				
				%maxvel=(%this.getDatablock().maxWheelSpeed*2)*(1+($Pref::VehicleNitro::MaxSpeedBoost/100)); //Get the torque unit speed, then 25% extra it
				
				//CHECK if their velocity is still below their 25% extra speed, if so then add velocity
				if(%speed < %maxvel){
					%this.setVelocity(vectorAdd(%this.getVelocity(),(%x * %forwardY + %y * %forwardX) SPC (%y * %forwardY + %x * -%forwardX) SPC %z));
				}
			}
		}else{ //If it not firing.
			if(%obj.client.nitro  < %maxnitro){ //If client had used some nitro up. Start regenerating.
				%obj.client.nitro += $Pref::VehicleNitro::RefillRate; //Add nitro.
			}
		}
			
		%shown = 1;
		%text = "<color:fff000>BPS<color:ffffff>: " @ %speed @ " <color:00cccc>Nitro<color:ffffff>:" SPC mFloor(%obj.client.nitro) SPC "% (Mouse-fire)"; //Display the nitro status.
		%obj.client.bottomPrint(%text,1,1); //Bottom print it for 1 second.
	}
		
	if(%shown){ //If shown meaning if the client is in the vehicle.
		%this.updateStatus = %this.schedule(100,updateStatus); //Repeat it every 1/10th of a second.
	}
}